'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

/* global Reflect, Promise */
var _extendStatics = function extendStatics(d, b) {
  _extendStatics = Object.setPrototypeOf || {
    __proto__: []
  } instanceof Array && function (d, b) {
    d.__proto__ = b;
  } || function (d, b) {
    for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p];
  };

  return _extendStatics(d, b);
};

function __extends(d, b) {
  if (typeof b !== "function" && b !== null) throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");

  _extendStatics(d, b);

  function __() {
    this.constructor = d;
  }

  d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}
function __awaiter(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
}
function __generator(thisArg, body) {
  var _ = {
    label: 0,
    sent: function sent() {
      if (t[0] & 1) throw t[1];
      return t[1];
    },
    trys: [],
    ops: []
  },
      f,
      y,
      t,
      g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;

  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }

  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");

    while (_) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];

      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;

        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };

        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;

        case 7:
          op = _.ops.pop();

          _.trys.pop();

          continue;

        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }

          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }

          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }

          if (t && _.label < t[2]) {
            _.label = t[2];

            _.ops.push(op);

            break;
          }

          if (t[2]) _.ops.pop();

          _.trys.pop();

          continue;
      }

      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }

    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
}

var Chunk = (function () {
    function Chunk() {
        this.identifier = 'chunk';
        this.done = false;
    }
    return Chunk;
}());

var DelayChunk = (function (_super) {
    __extends(DelayChunk, _super);
    function DelayChunk(ms) {
        var _this = _super.call(this) || this;
        _this.done = false;
        _this.identifier = 'chunk';
        _this.ms = ms;
        return _this;
    }
    DelayChunk.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, new Promise(function (resolve) {
                            _this.timeoutId = setTimeout(resolve, _this.ms);
                        })];
                    case 1:
                        _a.sent();
                        this.done = true;
                        return [2];
                }
            });
        });
    };
    DelayChunk.prototype.stop = function () {
        clearTimeout(this.timeoutId);
        this.done = true;
    };
    return DelayChunk;
}(Chunk));

var FetchChunk = (function (_super) {
    __extends(FetchChunk, _super);
    function FetchChunk(resource, options) {
        var _this = _super.call(this) || this;
        _this.done = false;
        _this.identifier = 'chunk';
        _this.controller = new AbortController();
        _this.resource = resource;
        _this.options = options;
        _this.options.signal = _this.controller.signal;
        return _this;
    }
    FetchChunk.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, fetch(this.resource, this.options)];
                    case 1:
                        response = _a.sent();
                        this.done = true;
                        return [2, response];
                }
            });
        });
    };
    FetchChunk.prototype.stop = function () {
        if (this.controller) {
            this.controller.abort();
        }
        this.done = true;
    };
    return FetchChunk;
}(Chunk));

function isPromise(obj) {
    return typeof (obj === null || obj === void 0 ? void 0 : obj.then) === 'function';
}
function isGenerator(obj) {
    return typeof (obj === null || obj === void 0 ? void 0 : obj.next) === 'function';
}
function isChunk(obj) {
    return (obj === null || obj === void 0 ? void 0 : obj.identifier) === 'chunk';
}

var GeneratorChunk = (function (_super) {
    __extends(GeneratorChunk, _super);
    function GeneratorChunk(generator) {
        var _this = _super.call(this) || this;
        _this.stopped = false;
        _this.nestedChunks = [];
        _this.generator = generator;
        return _this;
    }
    GeneratorChunk.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var next, _a, _b, nested, _c, error_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        next = { value: undefined, done: false };
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 10, , 11]);
                        _d.label = 2;
                    case 2:
                        if (!(!this.stopped && !next.done)) return [3, 9];
                        next = this.generator.next(next.value);
                        if (!isChunk(next.value)) return [3, 4];
                        this.nestedChunks.push(next.value);
                        _a = next;
                        return [4, next.value.run()];
                    case 3:
                        _a.value = _d.sent();
                        _d.label = 4;
                    case 4:
                        if (!isPromise(next.value)) return [3, 6];
                        _b = next;
                        return [4, next.value];
                    case 5:
                        _b.value = _d.sent();
                        _d.label = 6;
                    case 6:
                        if (!isGenerator(next.value)) return [3, 8];
                        nested = new GeneratorChunk(next.value);
                        this.nestedChunks.push(nested);
                        _c = next;
                        return [4, nested.run()];
                    case 7:
                        _c.value = _d.sent();
                        _d.label = 8;
                    case 8: return [3, 2];
                    case 9: return [3, 11];
                    case 10:
                        error_1 = _d.sent();
                        this.done = true;
                        throw error_1;
                    case 11:
                        this.done = true;
                        return [2, next.value];
                }
            });
        });
    };
    GeneratorChunk.prototype.stop = function () {
        this.stopped = true;
        this.nestedChunks.forEach(function (chunk) { return chunk.stop(); });
        this.done = true;
    };
    return GeneratorChunk;
}(Chunk));

var Runner = (function () {
    function Runner(generatorFn) {
        this.generatorFn = generatorFn;
    }
    Runner.prototype.run = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        this.chunk = new GeneratorChunk(this.generatorFn.apply(this, args));
        this.chunk.run();
    };
    Runner.prototype.stop = function () {
        if (this.chunk) {
            this.chunk.stop();
        }
    };
    return Runner;
}());

var LastRunner = (function (_super) {
    __extends(LastRunner, _super);
    function LastRunner() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LastRunner.prototype.run = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (this.chunk) {
            this.chunk.stop();
        }
        this.chunk = new GeneratorChunk(this.generatorFn.apply(this, args));
        this.chunk.run();
    };
    LastRunner.prototype.stop = function () {
        if (this.chunk) {
            this.chunk.stop();
        }
    };
    return LastRunner;
}(Runner));

var FirstRunner = (function (_super) {
    __extends(FirstRunner, _super);
    function FirstRunner() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FirstRunner.prototype.run = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (this.chunk && !this.chunk.done) {
            return;
        }
        this.chunk = new GeneratorChunk(this.generatorFn.apply(this, args));
        this.chunk.run();
    };
    FirstRunner.prototype.stop = function () {
        if (this.chunk) {
            this.chunk.stop();
        }
    };
    return FirstRunner;
}(Runner));

exports.DelayChunk = DelayChunk;
exports.FetchChunk = FetchChunk;
exports.FirstRunner = FirstRunner;
exports.LastRunner = LastRunner;
exports.Runner = Runner;
//# sourceMappingURL=index.js.map
